#华为云·寻找黑马程序员#【代码重构之路】如何优雅的关闭外部资源

1、背景

在Java编程中,如果打开了外部资源(文件、数据库连接、网络连接等),我们必须在这些外部资源使用完毕后,手动关闭它们。因为外部资源不由JVM管理,无法享用JVM的垃圾回收机制,如果我们不在编程时确保在正确的时机关闭外部资源,就会导致外部资源泄露,紧接着就会出现文件被异常占用,数据库连接过多导致连接池溢出等诸多很严重的问题

2、传统的资源关闭

为了确保外部资源一定要被关闭,通常关闭代码被写入finally代码块中,当然我们还必须注意到关闭资源时可能抛出的异常,于是变有了下面的经典代码

FileInputStream fis = null;
try {
	fis = new FileInputStream(new File("test"));
    System.out.println(fis.read());
} catch (IOException e) {
    e.printStackTrace();
} finally {
    if (fis != null) {
    	try {
        	fis.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
     }
}
  • 关闭外部资源时,每次都要判空,调用close时还要继续捕获异常
  • 当try中打开了多个外部资源时,需要逐个关闭,finally代码臃肿

3、重构
3.1 try-with-resources

在JDK1.7及其之后,可以使用try-with-resources语法,来重构上面的代码,使其更加简洁
那什么是try-with-resources呢?简而言之,当一个外部资源的句柄对象(比如FileInputStream对象)实现了AutoCloseable或者Closeable接口,那么就可以将上面的样式代码简化为如下形式:
 

try (FileInputStream fis = new FileInputStream(new File("test"))) {
	System.out.println(fis.read());
} catch (IOException e) {
    e.printStackTrace();
}
  • 被自动关闭的资源需要实现Closeable或者AutoCloseable接口
  • 将要关闭的外部资源在try()中创建,catch()捕获处理异常
  • 自动调用资源的close方法

将外部资源的句柄对象的创建放在try关键字后面的括号中,当这个try-catch代码块执行完毕后,Java会确保外部资源的close方法被调用,代码瞬间简洁了很多

3.2 原理

try-with-resources机制是一种语法糖,其底层实现原理仍然是try-catch-finally写法,我们可以来看下上面那段代码反编译后的效果:

try {
	FileInputStream fis = new FileInputStream(new File("test"));
    Throwable var2 = null;
    try {
    	System.out.println(fis.read());
    } catch (Throwable var12) {
    	var2 = var12;
        throw var12;
    } finally {
        if (fis != null) {
        	if (var2 != null) {
                try {
                    fis.close();
                } catch (Throwable var11) {
                    var2.addSuppressed(var11);
                }
             } else {
                    fis.close();
             }
         }
     }
} catch (IOException var14) {
    var14.printStackTrace();
}       

大家可能注意到代码中有一处对异常的特殊处理

var2.addSuppressed(var11);

这是try-with-resources语法涉及的另外一个知识点,叫做异常抑制。当对外部资源进行处理时,如果遭遇了异常,且在随后的关闭外部资源过程中,又遭遇了异常,那么你catch到的将会是对外部资源进行处理时遭遇的异常,关闭资源时遭遇的异常将被“抑制”但不是丢弃,通过异常的getSuppressed方法,可以提取出被抑制的异常

3.3 try-with-resources 也支持声明多个资源

try (FileInputStream fin = new FileInputStream(new File("input.txt"));
	FileOutputStream fout = new FileOutputStream(new File("out.txt"));
    GZIPOutputStream out = new GZIPOutputStream(fout)) {
    byte[] buffer = new byte[4096];
    int read;
    while ((read = fin.read(buffer)) != -1) {
    	out.write(buffer, 0, read);
    }
} catch (IOException e) {
	e.printStackTrace();
}
  • 资源关闭会按声明时的相反顺序被执行

来源:华为云社区征文 作者:EmindCC

发布了877 篇原创文章 · 获赞 5228 · 访问量 66万+
展开阅读全文

没有更多推荐了,返回首页

分享到微信朋友圈

×

扫一扫,手机浏览